/****************************************************
 * Function:
 *	produce slices.xml from slices.csv
 * Syntax:
 *	cscript makeXML.js [slides.csv] [slides.xml]
 *
 * Notice:
 * 	the difference of following:
 *		WScript.StdOut.WriteLine(s); //not work with wscript
 *		WScript.echo (s);
 ****************************************************/


var iNum = 8;		//maximum number of items perline

//Process command lines
var sInput = "slides.csv";
var sOutput= "slides.xml";
var objArgs = WScript.Arguments;

if (objArgs.Count()>0) {
	sInput = objArgs(0);
if (objArgs.Count()>1)
	sOutput = objArgs(1);
}
	
//open files
var fso = new ActiveXObject("Scripting.FileSystemObject");

var fout = fso.CreateTextFile(sOutput, true);
var fin = fso.OpenTextFile(sInput);

processCSV(fin, fout);	

fin.Close();
fout.Close();
	
//split a line by ","
function splitLine(s, sArray)
{
	var i, ii;
	var cnt = 0;
	i=0; ii = s.indexOf(",");
	while ((ii>=0) && (cnt<iNum-1)) {
		sArray[cnt] = s.substring(i, ii);
		cnt ++;
		i = ii+1;
		ii = s.indexOf(",", i);
	}
	if (i>0 && i<s.length && cnt < iNum-1)
		sArray[cnt] = s.substring(i);
	return cnt;
}

function stripSpace(s)
{
	var iB, iE;
	iB = 0; 
	iE = s.length - 1;
	while (iB<=iE && s.charAt(iB)==" ") iB++;
	while (iE>=iB && s.charAt(iE)==" ") iE--;
	return s.substring(iB, iE+1);
}

function processCSV(fin, fout)
{
	var s;
	var iCol;

	var sTag;	// = new Array(iNum);
	var sTagValue;	// = new Array(iNum);

	//Read header
	if (!fin.AtEndOfStream) {
		s = fin.ReadLine();
		sTag = s.split(",");
		iCol = sTag.length;
		while (iCol>0) {
			iCol--;
			sTag[iCol] = stripSpace(sTag[iCol]);
		}
	}

	fout.WriteLine("<?xml version=\"1.0\"?>");
	fout.WriteLine("<contents>");
	//process the rest of the lines
	while (!fin.AtEndOfStream) {
		s = fin.ReadLine();
		fout.WriteLine("  <record>");
		//ct = splitLine(s, sTagValue);
		sTagValue = s.split(",");
		ct = sTagValue.length-1;
		for (i=0; i<ct; i++) {
			fout.Write("\t<" + sTag[i] + ">");
			fout.Write(sTagValue[i]);
			fout.WriteLine("</" + sTag[i] + ">");
		}
		fout.WriteLine("  </record>");
	}
	fout.WriteLine("</contents>");
}
